//IS-2m tank, based on the Dragon Models Ltd. kit #6804.
//(Measurements in file are 1:35th in cm taken straight from kit.)
//Copyright (c) 2003 by Jakko Westerbeke <jakko@xs4all.nl>
sky_sphere {
   pigment {
      color rgb <1, 1, 1>
   }
}

light_source {
   <0, 20, 0>, rgb <1, 1, 1>
   shadowless
}

light_source {
   <0, 20, -50>, rgb <1, 1, 1>
   shadowless
}

camera {
   perspective
   location <-8, 10, -20>
   sky <0, 1, 0>
   direction <0, 0, 1>
   right <1.3333, 0, 0>
   up <0, 1, 0>
   look_at <3, 1, 0>
}

#declare DriveSprocket = union {
   //*PMName Drive sprocket
   
   cylinder {
      //*PMName Hullside mounting
      <16.55, 0.4, 2.25>, <16.55, 0.4, 2>, 0.85
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   cylinder {
      //*PMName Final drive housing 1
      <16.55, 0.4, 2.25>, <16.55, 0.4, 2.6>, 0.8
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   cone {
      //*PMName Final drive housing 2
      <16.55, 0.4, 2.6>, 0.8,
      <16.55, 0.4, 3>, 0.5
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   cylinder {
      //*PMName Sprocket ring inner
      <16.55, 0.4, 2.8>, <16.55, 0.4, 2.9>, 0.9
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   cone {
      //*PMName Wheel inner
      <16.55, 0.4, 2.9>, 0.7,
      <16.55, 0.4, 3.4>, 0.42
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   cone {
      //*PMName Wheel outer
      <16.55, 0.4, 3.4>, 0.42,
      <16.55, 0.4, 3.9>, 0.7
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   cylinder {
      //*PMName Sprocket ring outer
      <16.55, 0.4, 3.9>, <16.55, 0.4, 4>, 0.9
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   cone {
      //*PMName Hub
      <16.55, 0.4, 3.9>, 0.5,
      <16.55, 0.4, 4.1>, 0.1
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
}

#declare Wheel = union {
   cylinder {
      //*PMName Outer Wheel
      <0.515, 0.75, 0>, <0.68, 0.75, 0>, 0.75
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   difference {
      //*PMName Rim
      
      cylinder {
         //*PMName Outside
         <0.515, 0.75, 0>, <0.78, 0.75, 0>, 0.75
         scale <1, 1, 1>
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Inside
         <0.515, 0.75, 0>, <0.8, 0.75, 0>, 0.7
         scale <1, 1, 1>
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
   }
   
   cylinder {
      //*PMName Hub
      <0, 0.75, 0>, <0.78, 0.75, 0>, 0.35
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   cylinder {
      //*PMName Hubcap
      <0, 0.75, 0>, <0.82, 0.75, 0>, 0.25
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   cylinder {
      //*PMName Inner Wheel
      <0, 0.75, 0>, <0.265, 0.75, 0>, 0.75
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   rotate <0, 90, 0>
}

#declare ReturnRoller = union {
   //*PMName Return roller
   
   cylinder {
      //*PMName Flange
      <0, 1.1, -2.25>, <0, 1.1, -2.35>, 0.5
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   cone {
      //*PMName Mounting
      <0, 1.1, -2.25>, 0.35,
      <0, 1.1, -2.9>, 0.225
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   cylinder {
      //*PMName Inner wheel
      <0, 1.1, -2.85>, <0, 1.1, -3.05>, 0.55
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   cylinder {
      //*PMName Axle
      <0, 1.1, -3.05>, <0, 1.1, -3.25>, 0.15
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   difference {
      //*PMName Outer wheel
      
      cylinder {
         //*PMName Outer wheel
         <0, 1.1, -3.45>, <0, 1.1, -3.25>, 0.55
         scale <1, 1, 1>
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Recess
         <0, 1.1, -3.5>, <0, 1.1, -3.3>, 0.5
         scale <1, 1, 1>
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
   }
   
   cylinder {
      //*PMName Hubcap
      <0, 1.1, -3.35>, <0, 1.1, -3.45>, 0.2
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   cylinder {
      //*PMName Hubcap center
      <0, 1.1, -3.25>, <0, 1.1, -3.35>, 0.3
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
}

#declare Roadwheel = union {
   cylinder {
      //*PMName Wheel bearing
      <0, 0.75, 0.4>, <0, 0.75, 0>, 0.25
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   cylinder {
      //*PMName Torsion bar
      <1.3, 1.25, 0.4>, <1.3, 1.25, 0>, 0.25
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   cylinder {
      //*PMName Torsion bar
      <1.3, 1.25, 0.75>, <1.3, 1.25, 0.4>, 0.35
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   cylinder {
      //*PMName Suspension arm
      <0, 0.75, 0.175>, <1.4, 1.25, 0.175>, 0.175
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   union {
      //*PMName Bump stop
      
      box {
         //*PMName Back
         <-0.3, 1.4, 0.75>, <0.2, 1.95, 0.45>
         scale <1, 1, 1>
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      box {
         //*PMName Lower block
         <-0.3, 1.4, 0.75>, <0.2, 1.65, 0.3>
         scale <1, 1, 1>
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Lower round
         <-0.05, 1.4, 0.3>, <-0.05, 1.7, 0.3>, 0.25
         scale <1, 1, 1>
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      rotate <0, 0, 10>
      translate <0.2, -0.1, 0>
   }
   
   object {
      //*PMName Wheel
      Wheel
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   translate <-1.3, -1.25, -0.75>
   scale <-1, 1, 1>
}

#declare FuelTankSides = union {
   //*PMName Fuel tank hull side
   
   cylinder {
      //*PMName Tank
      <0, 0.5, 0>, <2.9, 0.5, 0>, 0.5
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   cylinder {
      //*PMName Filler cap
      <1.45, 1.1, 0>, <1.45, 0.9, 0>, 0.1
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   cylinder {
      //*PMName Strap F
      <0.75, 0.5, 0>, <0.85, 0.5, 0>, 0.52
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   box {
      //*PMName Mount F straight bit
      <0.75, 0.15, 0.5>, <0.85, -0.25, 0>
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   cylinder {
      //*PMName Mount F rounded bit
      <0.75, 0.15, 0>, <0.85, 0.15, 0>, 0.4
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   cylinder {
      //*PMName Strap R
      <2.5, 0.5, 0>, <2.4, 0.5, 0>, 0.52
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   box {
      //*PMName Mount R straight bit
      <2.5, 0.15, 0.5>, <2.4, -0.25, 0>
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   cylinder {
      //*PMName Mount R rounded bit
      <2.5, 0.15, 0>, <2.4, 0.15, 0>, 0.4
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   rotate <10, 0, 0>
}

#declare FuelTankRear = union {
   //*PMName Fuel tank rear
   
   cylinder {
      //*PMName Tank
      <0, 0.5, 0>, <2.9, 0.5, 0>, 0.72
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   cylinder {
      //*PMName Strap L
      <0.7, 0.5, 0>, <0.65, 0.5, 0>, 0.74
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Mount L
      linear_spline
      linear_sweep
      0.65, 0.7,
      5,
      <0.25, -0.75>, <0.25, 0.75>, <-0.5, 0.3>, <-0.5, -0.3>, <0.25, -0.75>
      scale <-1, 1, 1>
      rotate <0, 0, -90>
      translate <0, 0, 0>
   }
   
   cylinder {
      //*PMName Ridge L
      <0.85, 0.5, 0>, <0.95, 0.5, 0>, 0.76
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   cylinder {
      //*PMName Strap R
      <2.2, 0.5, 0>, <2.25, 0.5, 0>, 0.74
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Mount R
      linear_spline
      linear_sweep
      2.2, 2.25,
      5,
      <0.25, -0.75>, <0.25, 0.75>, <-0.5, 0.3>, <-0.5, -0.3>, <0.25, -0.75>
      scale <-1, 1, 1>
      rotate <0, 0, -90>
      translate <0, 0, 0>
   }
   
   cylinder {
      //*PMName Ridge R
      <1.95, 0.5, 0>, <2.05, 0.5, 0>, 0.76
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   rotate <-40, -90, 0>
}

#declare Grille = union {
   //*PMName Grille
   
   box {
      //*PMName Black panel
      <13.2, 3.08, -2.25>, <15.1, 3, 2.25>
      
      pigment {
         color rgb <0, 0, 0>
      }
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Bar 1
      linear_spline
      linear_sweep
      -13.1, -13.3,
      4,
      <-2.5, 3.05>, <0, 3.25>, <2.5, 3.05>, <-2.5, 3.05>
      scale <1, 1, 1>
      rotate <0, 90, 90>
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Bar 2
      linear_spline
      linear_sweep
      -13.4, -13.5,
      4,
      <-2.5, 3.05>, <0, 3.25>, <2.5, 3.05>, <-2.5, 3.05>
      scale <1, 1, 1>
      rotate <0, 90, 90>
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Bar 3
      linear_spline
      linear_sweep
      -13.6, -13.7,
      4,
      <-2.5, 3.05>, <0, 3.25>, <2.5, 3.05>, <-2.5, 3.05>
      scale <1, 1, 1>
      rotate <0, 90, 90>
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Bar 4
      linear_spline
      linear_sweep
      -13.8, -13.9,
      4,
      <-2.5, 3.05>, <0, 3.25>, <2.5, 3.05>, <-2.5, 3.05>
      scale <1, 1, 1>
      rotate <0, 90, 90>
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Bar 5
      linear_spline
      linear_sweep
      -14, -14.1,
      4,
      <-2.5, 3.05>, <0, 3.25>, <2.5, 3.05>, <-2.5, 3.05>
      scale <1, 1, 1>
      rotate <0, 90, 90>
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Bar 6
      linear_spline
      linear_sweep
      -14.2, -14.3,
      4,
      <-2.5, 3.05>, <0, 3.25>, <2.5, 3.05>, <-2.5, 3.05>
      scale <1, 1, 1>
      rotate <0, 90, 90>
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Bar 7
      linear_spline
      linear_sweep
      -14.4, -14.5,
      4,
      <-2.5, 3.05>, <0, 3.25>, <2.5, 3.05>, <-2.5, 3.05>
      scale <1, 1, 1>
      rotate <0, 90, 90>
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Bar 8
      linear_spline
      linear_sweep
      -14.6, -14.7,
      4,
      <-2.5, 3.05>, <0, 3.25>, <2.5, 3.05>, <-2.5, 3.05>
      scale <1, 1, 1>
      rotate <0, 90, 90>
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Bar 9
      linear_spline
      linear_sweep
      -14.8, -14.9,
      4,
      <-2.5, 3.05>, <0, 3.25>, <2.5, 3.05>, <-2.5, 3.05>
      scale <1, 1, 1>
      rotate <0, 90, 90>
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Bar 10
      linear_spline
      linear_sweep
      -15, -15.1,
      4,
      <-2.5, 3.05>, <0, 3.25>, <2.5, 3.05>, <-2.5, 3.05>
      scale <1, 1, 1>
      rotate <0, 90, 90>
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Bar 11
      linear_spline
      linear_sweep
      -15.2, -15.35,
      4,
      <-2.5, 3.05>, <0, 3.25>, <2.5, 3.05>, <-2.5, 3.05>
      scale <1, 1, 1>
      rotate <0, 90, 90>
      translate <0, 0, 0>
   }
}

#declare Headlight = union {
   //*PMName Headlight
   
   difference {
      //*PMName Dome
      
      sphere {
         //*PMName Dome
         <0, 0, 0>, 0.25
         scale <1.3, 1, 1>
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      plane {
         //*PMName Front face
         <1, 0, 0>, 0
         scale <1, 1, 1>
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
   }
   
   box {
      //*PMName Hood
      <-0.3, 0.1, -0.2>, <0, 0.2, 0.2>
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
}

#declare Suspension = union {
   //*PMName Suspension
   
   object {
      //*PMName Wheel 1
      Roadwheel
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <1, 0.1, -2.25>
   }
   
   object {
      //*PMName Wheel 2
      Roadwheel
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <3.45, 0.1, -2.25>
   }
   
   object {
      //*PMName Wheel 3
      Roadwheel
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <5.9, 0.1, -2.25>
   }
   
   object {
      //*PMName Wheel 4
      Roadwheel
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <8.35, 0.1, -2.25>
   }
   
   object {
      //*PMName Wheel 5
      Roadwheel
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <10.8, 0.1, -2.25>
   }
   
   object {
      //*PMName Wheel 6
      Roadwheel
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <13.25, 0.1, -2.25>
   }
   
   object {
      //*PMName Return roller 1
      ReturnRoller
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <3.4, 0, 0>
   }
   
   object {
      //*PMName Return roller 2
      ReturnRoller
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <8.35, 0, 0>
   }
   
   object {
      //*PMName Return roller 3
      ReturnRoller
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <13.35, 0, 0>
   }
}

#declare TrackGuard = union {
   box {
      //*PMName Top plate
      <0.7, 2.05, 2.25>, <17, 2, 4.3>
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   box {
      //*PMName Inside front plate
      <0.7, 2, 2.25>, <1.5, 1.25, 2.3>
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   intersection {
      //*PMName Front mudguard
      
      box {
         <0.7, 2.05, 2.2>, <-0.7, 1.25, 4.35>
         scale <1, 1, 1>
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      difference {
         //*PMName Front curve
         
         cylinder {
            //*PMName Outer
            <0.45, 1.4, 2.25>, <0.45, 1.4, 4.3>, 0.9
            scale <1.5, 0.9, 1>
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         cylinder {
            //*PMName Inner
            <0.45, 1.4, 2.3>, <0.45, 1.4, 4.35>, 0.85
            scale <1.5, 0.9, 1>
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
      }
   }
   
   intersection {
      //*PMName Front skirt
      
      cone {
         <0.45, 1.4, 4.3>, 0.9,
         <0.45, 1.4, 4.5>, 0.6
         scale <1.5, 0.9, 1>
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      plane {
         <0, -1, 0>, 0
         scale <1, 1, 1>
         rotate <0, 0, 15>
         translate <-0.7, 1.25, 4.3>
      }
   }
   
   prism {
      //*PMName Middle skirt
      linear_spline
      linear_sweep
      0.7, 17,
      5,
      <2.05, 4.3>, <1.8, 4.5>, <1.65, 4.5>, <1.65, 4.3>, <2.05, 4.3>
      scale <-1, 1, 1>
      rotate <0, 0, -90>
      translate <0, 0, 0>
   }
   
   intersection {
      //*PMName Rear mudguard
      
      box {
         <17, 2.05, 2.2>, <18.5, 1.25, 4.35>
         scale <1, 1, 1>
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      difference {
         //*PMName Rear curve
         
         cylinder {
            //*PMName Outer
            <11.35, 1.4, 2.25>, <11.35, 1.4, 4.3>, 0.9
            scale <1.5, 0.9, 1>
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         cylinder {
            //*PMName Inner
            <11.35, 1.4, 2.3>, <11.35, 1.4, 4.35>, 0.85
            scale <1.5, 0.9, 1>
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
      }
   }
   
   intersection {
      //*PMName Rear skirt
      
      cone {
         <11.35, 1.4, 4.3>, 0.9,
         <11.35, 1.4, 4.5>, 0.6
         scale <1.5, 0.9, 1>
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      plane {
         <0, -1, 0>, 0
         scale <1, 1, 1>
         rotate <0, 0, -15>
         translate <18.3, 1.25, 4.3>
      }
   }
}

#declare TrackGuardBin = union {
   //*PMName Stowage bins
   
   difference {
      //*PMName Outer shape
      
      prism {
         //*PMName Basic shape
         linear_spline
         linear_sweep
         2.95, 9.9,
         5,
         <2.05, 2>, <3.1, 2>, <3.1, 3.375>, <2.05, 4.3>, <2.05, 2>
         scale <-1, 1, 1>
         rotate <0, 0, -90>
         translate <0, 0, 0>
      }
      
      plane {
         //*PMName Front panel
         <0, -1, 0>, 0
         scale <1, 1, 1>
         rotate <0, 0, 30>
         translate <3.1, 2.05, 2.25>
      }
   }
   
   box {
      //*PMName Lid 1
      <5, 2, 0>, <6.75, 2.7, 0.2>
      scale <1, 1, 1>
      rotate <-38, 0, 0>
      translate <0, 0.5, 5.3>
   }
   
   box {
      //*PMName Lid 2
      <7, 2, 0>, <8.75, 2.7, 0.2>
      scale <1, 1, 1>
      rotate <-38, 0, 0>
      translate <0, 0.5, 5.3>
   }
}

#declare Hull = union {
   //*PMName IS-2
   
   union {
      //*PMName Upper hull front
      
      intersection {
         //*PMName Glacis
         
         box {
            //*PMName Basic glacis
            <0, 1.35, -2.25>, <4.1, 3.05, 2.25>
            scale <1, 1, 1>
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         plane {
            //*PMName Front
            <0, 1, 0>, 0
            scale <1, 1, 1>
            rotate <0, 0, 30>
            translate <0, 1.35, 0>
         }
         
         plane {
            //*PMName Side R
            <0, 1, 0>, 0
            scale <1, 1, 1>
            rotate <40, 0, 0>
            translate <0, 2.05, 2.25>
         }
         
         plane {
            //*PMName Side L
            <0, 1, 0>, 0
            scale <1, 1, 1>
            rotate <-40, 0, 0>
            translate <0, 2.05, -2.25>
         }
      }
      
      bicubic_patch {
         //*PMName Hull side R
         type 0
         u_steps 2
         v_steps 2
         <6.6, 2.05, -3.625>, <6.6, 2.383, -3.542>, <6.6, 2.716, -3.458>, <6.6, 3.05, -3.375>,
         <4.5, 2.05, -3>, <4.8, 2.383, -3.2>, <5, 2.716, -3.35>, <5.1, 3.05, -3.5>,
         <3.5, 2.05, -2.7>, <3.7, 2.383, -2.6>, <3.8, 2.716, -2.5>, <3.9, 3.05, -2.4>,
         <2.95, 2.05, -2.25>, <2.95, 2.383, -1.875>, <2.95, 2.716, -1.5>, <2.95, 3.05, -1.125>
         scale <1, 1, -1>
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      prism {
         //*PMName Front hull roof R
         linear_spline
         linear_sweep
         3.05, 3,
         7,
         <6.6, -3.375>, <5.5, -3.25>, <4.55, -2.75>, <3.73, -2.05>, <2.95, -1.125>, <2.95, 0>, <6.6, -3.375>
         scale <1, 1, -1>
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      bicubic_patch {
         //*PMName Hull side L
         type 0
         u_steps 2
         v_steps 2
         <6.6, 2.05, -3.625>, <6.6, 2.383, -3.542>, <6.6, 2.716, -3.458>, <6.6, 3.05, -3.375>,
         <4.5, 2.05, -3>, <4.8, 2.383, -3.2>, <5, 2.716, -3.35>, <5.1, 3.05, -3.5>,
         <3.5, 2.05, -2.7>, <3.7, 2.383, -2.6>, <3.8, 2.716, -2.5>, <3.9, 3.05, -2.4>,
         <2.95, 2.05, -2.25>, <2.95, 2.383, -1.875>, <2.95, 2.716, -1.5>, <2.95, 3.05, -1.125>
         scale <1, 1, 1>
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      prism {
         //*PMName Front hull roof L
         linear_spline
         linear_sweep
         3.05, 3,
         7,
         <6.6, -3.375>, <5.5, -3.25>, <4.55, -2.75>, <3.73, -2.05>, <2.95, -1.125>, <2.95, 0>, <6.6, -3.375>
         scale <1, 1, 1>
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
   }
   
   union {
      //*PMName Rear deck
      
      intersection {
         //*PMName Upper hull rear
         
         prism {
            //*PMName Engine deck
            linear_spline
            linear_sweep
            0, 10.4,
            5,
            <0, 0>, <7.25, 0>, <7, 1>, <0.25, 1>, <0, 0>
            scale <1, 1, 1>
            rotate <-90, 90, 0>
            translate <17, 2.05, 3.625>
         }
         
         plane {
            //*PMName Rear hull slope
            <0, 1, 0>, 0
            scale <1, 1, 1>
            rotate <0, 0, -40>
            translate <17, 2.05, 0>
         }
      }
      
      object {
         //*PMName Grille
         Grille
         scale <1, 1, 1>
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      intersection {
         //*PMName Engine cover
         
         sphere {
            //*PMName Dome
            <11.7, 0.2, 0>, 3
            scale <1, 1, 1>
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         plane {
            <0, -1, 0>, 0
            scale <1, 1, 1>
            rotate <0, 0, 0>
            translate <11.7, 3, 0>
         }
      }
   }
   
   cylinder {
      //*PMName Turret ring
      <6.6, 2.05, 0>, <6.6, 3.1, 0>, 3.375
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   cylinder {
      //*PMName Periscope R
      <3.1, 3, 0.875>, <3.1, 3.2, 0.875>, 0.25
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   cylinder {
      //*PMName Periscope L
      <3.1, 3, -0.875>, <3.1, 3.2, -0.875>, 0.25
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   superellipsoid {
      //*PMName Driver's visor
      <0.2, 0.1>
      scale <0.35, 0.1, 0.5>
      rotate <0, 0, 24>
      translate <2, 2.45, 0>
   }
   
   object {
      //*PMName Track guard R
      TrackGuard
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   object {
      //*PMName Track guard L
      TrackGuard
      scale <1, 1, -1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   object {
      //*PMName Track guard stowage bin R
      TrackGuardBin
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   box {
      //*PMName Track guard bin R
      <2.1, 2.05, 2.5>, <2.95, 2.65, 4>
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   object {
      //*PMName Track guard stowage bin L
      TrackGuardBin
      scale <1, 1, -1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   superellipsoid {
      //*PMName Track guard oil tank L
      <0.25, 0.25>
      scale <0.6, 0.3, 0.8>
      rotate <0, 0, 0>
      translate <2.3, 2.35, -3.2>
   }
   
   cylinder {
      //*PMName Oil tank filler cap
      <2.7, 2.5, -3.8>, <2.7, 2.7, -3.8>, 0.1
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   prism {
      //*PMName Splash plate
      linear_spline
      linear_sweep
      0, 0.01,
      9,
      <1.5, -2.25>, <2.1, -2.25>, <2.1, -1.125>, <1.9, -0.8>, <1.9, 0.8>, <2.1, 1.125>, <2.1, 2.25>, <1.5, 2.25>, <1.5, -2.25>
      scale <1, 1, 1>
      rotate <0, 0, 100>
      translate <0.8, 0, 0>
   }
   
   object {
      //*PMName Headlight R
      Headlight
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0.75, 2.25, 1.5>
   }
   
   object {
      //*PMName Headlight L
      Headlight
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0.75, 2.25, -1.5>
   }
   
   prism {
      //*PMName Lower hull
      linear_spline
      linear_sweep
      -2.25, 2.25,
      7,
      <0.5, 0>, <0, 1.35>, <3.1, 2.05>, <17, 2.05>, <17.9, 1.3>, <17, 0>, <0.5, 0>
      scale <1, 1, 1>
      rotate <-90, 0, 0>
      translate <0, 0, 0>
   }
   
   object {
      //*PMName Suspension R
      Suspension
      scale <1, 1, -1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   object {
      //*PMName Suspension L
      Suspension
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0.5, 0, 0>
   }
   
   union {
      //*PMName Idler R
      
      object {
         //*PMName Wheel
         Wheel
         scale <1, 1, 1>
         rotate <0, 0, 0>
         translate <0.4, 0.15, -3>
      }
      
      box {
         //*PMName Mounting
         <0.2, 0.5, -2.6>, <0.8, 1.6, -3>
         scale <1, 1, 1>
         rotate <0, 0, -5>
         translate <-0.133333, 0.0333333, 0>
      }
      
      cylinder {
         //*PMName Hull axle
         <0.5, 1.3, -2.25>, <0.5, 1.3, -2.6>, 0.25
         scale <1, 1, 1>
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      scale <1, 1, -1>
   }
   
   union {
      //*PMName Idler L
      
      object {
         //*PMName Wheel
         Wheel
         scale <1, 1, 1>
         rotate <0, 0, 0>
         translate <0.4, 0.15, -3>
      }
      
      box {
         //*PMName Mounting
         <0.2, 0.5, -2.6>, <0.8, 1.6, -3>
         scale <1, 1, 1>
         rotate <0, 0, -5>
         translate <-0.133333, 0.0333333, 0>
      }
      
      cylinder {
         //*PMName Hull axle
         <0.5, 1.3, -2.25>, <0.5, 1.3, -2.6>, 0.25
         scale <1, 1, 1>
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
   }
   
   object {
      //*PMName Sprocket R
      DriveSprocket
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   object {
      //*PMName Sprocket L
      DriveSprocket
      scale <1, 1, -1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   union {
      //*PMName Track R
      
      box {
         //*PMName Upper run
         <0.4, 1.65, 2.4>, <13.4, 1.75, 4.3>
         scale <1, 1, 1>
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      box {
         //*PMName Upper run rear
         <13.3, 1.65, 2.4>, <16.55, 1.75, 4.3>
         scale <1, 1, 1>
         rotate <-0, 0, -6>
         translate <0, 1.4, 0>
      }
      
      difference {
         //*PMName Sprocket
         
         cylinder {
            <16.55, 0.4, 2.4>, <16.55, 0.4, 4.3>, 1
            scale <1, 1, 1>
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         cylinder {
            <16.55, 0.4, 2.35>, <16.55, 0.4, 4.35>, 0.9
            scale <1, 1, 1>
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         plane {
            <1, 0, 0>, 0
            scale <1, 1, 1>
            rotate <0, 0, 10>
            translate <16.75, 0, 0>
         }
      }
      
      box {
         //*PMName Lower run rear
         <14.5, -1, 2.4>, <17, -1.1, 4.3>
         scale <1, 1, 1>
         rotate <0, 0, 18.7>
         translate <0.548039, -4.87649, 0>
      }
      
      box {
         //*PMName Lower run
         <2, -1.15, 2.4>, <14.6, -1.25, 4.3>
         scale <1, 1, 1>
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      difference {
         //*PMName Idler
         
         cylinder {
            <0.4, 0.9, 2.4>, <0.4, 0.9, 4.3>, 0.85
            scale <1, 1, 1>
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         cylinder {
            <0.4, 0.9, 2.35>, <0.4, 0.9, 4.35>, 0.75
            scale <1, 1, 1>
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         plane {
            <-1, 0, 0>, 0
            scale <1, 1, 1>
            rotate <0, 0, -15>
            translate <0.4, 0.9, 0>
         }
      }
      
      box {
         //*PMName Lower run front
         <0.7, -1.15, 2.4>, <3.25, -1.25, 4.3>
         scale <1, 1, 1>
         rotate <-0, 0, -33.3>
         translate <0, 1.6, 0>
      }
      
      pigment {
         color rgb <0.654902, 0.419608, 0.32549>
      }
   }
   
   union {
      //*PMName Track L
      
      box {
         //*PMName Upper run
         <0.4, 1.65, -2.4>, <13.9, 1.75, -4.3>
         scale <1, 1, 1>
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      box {
         //*PMName Upper run rear
         <13.8, 1.65, -2.4>, <16.55, 1.75, -4.3>
         scale <1, 1, 1>
         rotate <-0, 0, -6>
         translate <0, 1.4, 0>
      }
      
      difference {
         //*PMName Sprocket
         
         cylinder {
            <16.55, 0.4, -2.4>, <16.55, 0.4, -4.3>, 1
            scale <1, 1, 1>
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         cylinder {
            <16.55, 0.4, -2.35>, <16.55, 0.4, -4.35>, 0.9
            scale <1, 1, 1>
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         plane {
            <1, 0, 0>, 0
            scale <1, 1, 1>
            rotate <0, 0, 10>
            translate <16.75, 0, 0>
         }
      }
      
      box {
         //*PMName Lower run rear
         <15.1, -1, -2.4>, <17, -1.1, -4.3>
         scale <1, 1, 1>
         rotate <0, -0, 22>
         translate <0.835419, -5.84599, 0>
      }
      
      box {
         //*PMName Lower run
         <2.75, -1.15, -2.4>, <15.25, -1.25, -4.3>
         scale <1, 1, 1>
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      difference {
         //*PMName Idler
         
         cylinder {
            <0.4, 0.9, -2.4>, <0.4, 0.9, -4.3>, 0.85
            scale <1, 1, 1>
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         cylinder {
            <0.4, 0.9, -2.35>, <0.4, 0.9, -4.35>, 0.75
            scale <1, 1, 1>
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         plane {
            <-1, 0, 0>, 0
            scale <1, 1, 1>
            rotate <0, 0, -15>
            translate <0.4, 0.9, 0>
         }
      }
      
      box {
         //*PMName Lower run front
         <0.7, -1.15, -2.4>, <3.7, -1.25, -4.3>
         scale <1, 1, 1>
         rotate <-0, 0, -28.4>
         translate <0, 1.6, 0>
      }
      
      pigment {
         color rgb <0.654902, 0.419608, 0.32549>
      }
   }
   
   union {
      //*PMName Fuel tanks sides
      
      object {
         //*PMName Fuel tank LF
         FuelTankSides
         scale <1, 1, 1>
         rotate <0, 0, 0>
         translate <10, 2.4, -4.05>
      }
      
      object {
         //*PMName Fuel tank LB
         FuelTankSides
         scale <-1, 1, 1>
         rotate <0, 0, 0>
         translate <16, 2.4, -4.05>
      }
      
      object {
         //*PMName Fuel tank RF
         FuelTankSides
         scale <1, 1, -1>
         rotate <0, 0, 0>
         translate <10, 2.4, 4.05>
      }
      
      object {
         //*PMName Fuel tank RB
         FuelTankSides
         scale <-1, 1, -1>
         rotate <0, 0, 0>
         translate <16, 2.4, 4.05>
      }
   }
   
   union {
      //*PMName Fuel tanks rear
      
      object {
         //*PMName Fuel tank LR
         FuelTankRear
         scale <1, 1, 1>
         rotate <0, 0, 0>
         translate <16.5, 3.1, -4.1>
      }
      
      object {
         //*PMName Fuel tank RR
         FuelTankRear
         scale <1, 1, 1>
         rotate <0, 0, 0>
         translate <16.5, 3.1, 1.2>
      }
   }
   
   pigment {
      color rgb <0.5, 0.5, 0>
   }
}

#declare Turret = union {
   //*PMName Turret
   
   difference {
      //*PMName Basic shape
      
      union {
         cone {
            <0.3, 0.2, 0>, 4.2,
            <0.3, 2.4, 0>, 3.4
            scale <1, 1, 1>
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         box {
            <2, 0.5, -3.2>, <-4, 2.4, 3.2>
            scale <1, 1, 1>
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
      }
      
      plane {
         //*PMName Front
         <0, -1, 0>, 0
         scale <1, 1, 1>
         rotate <0, 0, 82>
         translate <-2.7, 2.4, 0>
      }
      
      plane {
         //*PMName Side RF
         <0, -1, 0>, 0
         scale <1, 1, 1>
         rotate <70, -20, 0>
         translate <-2.8, 2.4, 1.75>
      }
      
      plane {
         //*PMName Cheek R
         <0, 1, 0>, 0
         scale <1, 1, 1>
         rotate <-45, -40, 0>
         translate <-2.8, 0.7, 2.25>
      }
      
      plane {
         //*PMName Side RB
         <0, -1, 0>, 0
         scale <1, 1, 1>
         rotate <70, 5, 0>
         translate <0, 2.4, 2.45>
      }
      
      plane {
         //*PMName Side LF
         <0, -1, 0>, 0
         scale <1, 1, 1>
         rotate <-70, 20, 0>
         translate <-2.8, 2.4, -1.75>
      }
      
      plane {
         //*PMName Cheek L
         <0, 1, 0>, 0
         scale <1, 1, 1>
         rotate <45, 40, 0>
         translate <-2.8, 0.7, -2.25>
      }
      
      plane {
         //*PMName Side LB
         <0, -1, 0>, 0
         scale <1, 1, 1>
         rotate <-70, -5, 0>
         translate <0, 2.4, -2.45>
      }
      
      plane {
         //*PMName Roof F
         <0, -1, 0>, 0
         scale <1, 1, 1>
         rotate <0, 0, 2>
         translate <-0.7, 2.4, 0>
      }
   }
   
   cylinder {
      //*PMName Turret ring
      <0, 0, 0>, <0, 0.4, 0>, 3.1
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   cone {
      //*PMName MG mount
      <2.7, 1.2, -1.7>, 0.7,
      <4, 1.2, -1.7>, 0.6
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   union {
      //*PMName Mantlet
      
      blob {
         //*PMName Mantlet
         threshold 0.5
         
         cylinder {
            <-3, 1.1, -1.2>, <-3, 1.1, 1.2>, 1.1,
            strength 10
         }
         
         cylinder {
            <-2.5, 1.45, -1.2>, <-2.5, 1.45, 1.2>, 1,
            strength 10
         }
         scale <1, 1, 1>
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      cylinder {
         //*PMName Gun sleeve
         <-3, 1.2, 0>, <-4.5, 1.2, 0>, 0.4
         scale <1, 1, 1>
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      cone {
         //*PMName Gun barrel
         <-4.5, 1.2, 0>, 0.33,
         <-14, 1.2, 0>, 0.2
         scale <1, 1, 1>
         rotate <0, 0, 0>
         translate <0, 0, 0>
      }
      
      difference {
         //*PMName Muzzle brake
         
         union {
            //*PMName Basic shape
            
            cylinder {
               //*PMName Rear section
               <-14, 1.2, 0>, <-14.2, 1.2, 0>, 0.3
               scale <1, 1, 1>
               rotate <0, 0, 0>
               translate <0, 0, 0>
            }
            
            cone {
               //*PMName Middle section
               <-14.2, 1.2, 0>, 0.3,
               <-14.9, 1.2, 0>, 0.4
               scale <1, 1, 1>
               rotate <0, 0, 0>
               translate <0, 0, 0>
            }
            
            cylinder {
               //*PMName Front section
               <-14.9, 1.2, 0>, <-15.75, 1.2, 0>, 0.4
               scale <1, 1, 1>
               rotate <0, 0, 0>
               translate <0, 0, 0>
            }
         }
         
         cylinder {
            //*PMName Bore
            <-15.8, 1.2, 0>, <-14, 1.2, 0>, 0.175
            
            pigment {
               color rgb <1, 0.5, 0>
            }
            scale <1, 1, 1>
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         cylinder {
            //*PMName Chamber
            <-15.65, 1.2, 0>, <-14.5, 1.2, 0>, 0.3
            
            pigment {
               color rgb <1, 0.5, 0>
            }
            scale <1, 1, 1>
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         box {
            //*PMName Brake Hole F
            <-15.25, 1, -0.5>, <-15.6, 1.4, 0.5>
            
            pigment {
               color rgb <1, 0.5, 0>
            }
            scale <1, 1, 1>
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
         
         box {
            //*PMName Brake Hole R
            <-15, 0.95, -0.5>, <-14.5, 1.45, 0.5>
            
            pigment {
               color rgb <1, 0.5, 0>
            }
            scale <1, 1, 1>
            rotate <0, 0, 0>
            translate <0, 0, 0>
         }
      }
   }
   
   cylinder {
      //*PMName Loader's hatch
      <1, 2.3, 1>, <1, 2.45, 1>, 0.75
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   torus {
      //*PMName Commander's cupola
      0.55, 0.6
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <1.4, 2.4, -1.25>
   }
   
   cylinder {
      //*PMName Commander's hatches
      <1.4, 2.5, -1.25>, <1.4, 3.05, -1.25>, 0.75
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   cylinder {
      //*PMName Periscope R
      <-1.2, 2.3, 1.55>, <-1.2, 2.6, 1.55>, 0.25
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   cylinder {
      //*PMName Periscope L
      <-1.2, 2.3, -1.55>, <-1.2, 2.6, -1.55>, 0.25
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   cylinder {
      //*PMName Periscope C
      <0.9, 3, -1.25>, <0.9, 3.25, -1.25>, 0.25
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   sphere {
      //*PMName Ventilator roof
      <-1.15, 4.8, 0.6>, 0.6
      scale <1, 0.5, 1>
      rotate <0, 0, 2>
      translate <0, 0, 0>
   }
   
   sphere {
      //*PMName Ventilator rear
      <3.9, 1.2, -1.7>, 0.4
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
}

union {
   //*PMName IS-2M
   
   object {
      //*PMName Hull
      Hull
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <0, 0, 0>
   }
   
   object {
      //*PMName Turret
      Turret
      scale <1, 1, 1>
      rotate <0, 0, 0>
      translate <6.6, 3.1, 0>
   }
   
   pigment {
      color rgb <0.5, 0.5, 0>
   }
}